function love.load()
    track = {
        tex = love.graphics.newImage('tex.png'),
    }

    screen = {
        w = love.graphics.getWidth(),
        h = love.graphics.getHeight(),
    }
    canvas = love.image.newImageData(screen.w, screen.h)
    canvas = love.graphics.newImage(canvas)
    screen.aspect = screen.w/screen.h
    shader = love.graphics.newShader [[
        extern Image map;
        extern number x = 0;   // X position on map
        extern number y = 0;   // Y position on map
        extern number z = 1;  // Zoom
        extern number a = 1;   // Angle
        extern number r = 0;   // Rotation
        extern number o = 1; // Player offset
        extern number aspect = 1; // Aspect ratio correction
        vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
        {

            //I dont even know how this works
            mat2 rotation = mat2( cos(r), sin(r),
                                -sin(r), cos(r));

            //Rotates it first
            vec2 uv = vec2((texture_coords.x - .5)/z, (1 - texture_coords.y - (1-o))/z)*rotation;

            //Distorts it to make it a flat, 3D looking plane
            vec2 uv2         = vec2(
                (uv.x / (texture_coords.y*a) + x)*aspect,
                mod((uv.y / (texture_coords.y*a) + y), 1)
            );

            vec2 uv3         = vec2(
                uv2.x + (x-.5/aspect)*2,
                mod(uv2.y, 1)
            );
         return texture2D(map,uv3).xyzw;
        }
    ]]
    shader:send('map', track.tex)
    shader:send('aspect', screen.aspect)

    camera = {
        x = .25,
        y = 0,
        r = 0,
    }

end

function love.update(dt2)
    dt = dt2
    if love.keyboard.isDown('right') then
        camera.x = camera.x + dt
    end
    if love.keyboard.isDown('left') then
        camera.x = camera.x - dt
    end
    if love.keyboard.isDown('up') then
        camera.y = camera.y + dt*4
    end
    if love.keyboard.isDown('down') then
        camera.y = camera.y - dt*4
    end
    if love.keyboard.isDown('=') then
        camera.r = camera.r + dt
    end
    if love.keyboard.isDown('-') then
        camera.r = camera.r - dt
    end
end

function love.draw()
    shader:send('x', camera.x)
    shader:send('y', camera.y)
    shader:send('r', camera.r)
    love.graphics.setShader(shader)
    love.graphics.draw(canvas, 0, 0)
    love.graphics.setShader()
end

function love.keypressed(key)
    if key =='escape' then love.event.quit() end
end